<template>
	<div class="FieldsView">
		<fields-view-controls />
		<div class="FieldsView-container">
			<div class="FieldsView-mobileContainer" v-if="$vuetify.breakpoint.smAndDown">
				<div>
					<fields-view-map v-if="isLoaded" class="FieldsViewMapMobile" @focus="collapseSheet" mobile />
					<fields-list-sheet ref="sheetRef" />
				</div>
			</div>
			<div v-else class="FieldsView-splitContainer">
				<div class="text-center py-6" v-if="isLoading">
					<v-progress-circular :size="50" indeterminate color="primary" />
				</div>
				<template v-else>
					<div class="FieldsView-splitContainer-left">
						<fields-list v-if="$vuetify.breakpoint.lgAndDown" />
						<fields-table v-else />
					</div>
					<div class="FieldsView-splitContainer-right">
						<fields-view-map v-if="isLoaded" class="FieldsViewMapDesktop" />
					</div>
				</template>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, onMounted, ref } from '@vue/composition-api';
import { useFieldsView } from '@/store/modules/fieldsView';
import { useGroups } from '@/store/modules/group';
import { useAllResources } from '@/store/modules/resources';
import FieldsList from './FieldsList/FieldsList.vue';
import FieldsListSheet, { FieldsListSheetProps } from './FieldsList/FieldsListSheet.vue';
import FieldsTable from './FieldsTable/FieldsTable.vue';
import FieldsViewControls from './FieldsViewControls/FieldsViewControls.vue';
import FieldsViewMap from './FieldsViewMap/FieldsViewMap.vue';

export default defineComponent({
	components: {
		FieldsViewMap,
		FieldsViewControls,
		FieldsTable,
		FieldsList,
		FieldsListSheet,
	},
	setup(_, { root }) {
		const sheetRef = ref<FieldsListSheetProps | null>(null);
		const { isLoaded: areResourcesLoaded, isLoading: areResourcesLoading } = useAllResources(root.$store);
		const { isLoaded: areGroupsLoaded, isLoading: areGroupsLoading } = useGroups(root.$store);
		const { setFiltersFromUrl } = useFieldsView(root.$store);
		const isLoading = computed(() => areGroupsLoading.value || areResourcesLoading.value);
		const isLoaded = computed(() => areGroupsLoaded.value && areResourcesLoaded.value);

		const collapseSheet = () => {
			sheetRef.value?.collapse();
		};

		onMounted(() => {
			setFiltersFromUrl();
		});

		return {
			isLoaded,
			isLoading,
			sheetRef,
			collapseSheet,
		};
	},
});
</script>

<style lang="scss">
.FieldsView {
	width: 100%;
	height: 100%;
	display: flex;
	flex-direction: column;

	.FieldsView-container {
		position: relative;
		padding-top: 67px;
		height: 100%;

		@media (min-width: 768px) and (max-width: 848px) {
			padding-top: 119px;
		}
	}
}

.FieldsView-mobileContainer {
	position: fixed;
	left: 0;
	right: 0;
	top: 123px;
	bottom: 0;

	& > div {
		position: relative;
		width: 100%;
		height: 100%;
		overflow: auto;
	}
}

.FieldsView-splitContainer {
	display: flex;
	flex-direction: row;
	height: 100%;
	min-height: 0;
	justify-content: center;

	.FieldsView-splitContainer-left,
	.FieldsView-splitContainer-right {
		position: relative;
		width: 50%;
		height: 100%;
	}
}
</style>
